diff --git a/src/backend/access/brin/brin.c b/src/backend/access/brin/brin.c
new file mode 100644
index 99337b0..a029eb1
*** a/src/backend/access/brin/brin.c
--- b/src/backend/access/brin/brin.c
***************
*** 35,40 ****
--- 35,143 ----
  
  
  /*
+  * BRIN handler function: return IndexAmRoutine with access method parameters
+  * and callbacks.
+  */
+ Datum
+ brinhandler(PG_FUNCTION_ARGS)
+ {
+ 	IndexAmRoutine *amroutine = makeNode(IndexAmRoutine);
+ 
+ 	amroutine->amstrategies = 0;
+ 	amroutine->amsupport = 15;
+ 	amroutine->amcanorder = false;
+ 	amroutine->amcanorderbyop = false;
+ 	amroutine->amcanbackward = false;
+ 	amroutine->amcanunique = false;
+ 	amroutine->amcanmulticol = true;
+ 	amroutine->amoptionalkey = true;
+ 	amroutine->amsearcharray = false;
+ 	amroutine->amsearchnulls = true;
+ 	amroutine->amstorage = true;
+ 	amroutine->amclusterable = false;
+ 	amroutine->ampredlocks = false;
+ 	amroutine->amkeytype = 0;
+ 
+ 	amroutine->aminsert = brininsert;
+ 	amroutine->ambeginscan = brinbeginscan;
+ 	amroutine->amgettuple = NULL;
+ 	amroutine->amgetbitmap = bringetbitmap;
+ 	amroutine->amrescan = brinrescan;
+ 	amroutine->amendscan = brinendscan;
+ 	amroutine->ammarkpos = brinmarkpos;
+ 	amroutine->amrestrpos = brinrestrpos;
+ 	amroutine->ambuild = brinbuild;
+ 	amroutine->ambuildempty = brinbuildempty;
+ 	amroutine->ambulkdelete = brinbulkdelete;
+ 	amroutine->amvacuumcleanup = brinvacuumcleanup;
+ 	amroutine->amcanreturn = NULL;
+ 	amroutine->amcostestimate = brincostestimate;
+ 	amroutine->amoptions = brinoptions;
+ 	amroutine->amvalidate = brinvalidate;
+ 
+ 	PG_RETURN_POINTER(amroutine);
+ }
+ 
+ void
+ brinvalidate(OpClassInfo *opclass)
+ {
+ 	ListCell   *l;
+ 	bool		procsPresent[BRIN_MANDATORY_NPROCS];
+ 	int			i;
+ 
+ 	memset(procsPresent, 0, sizeof(procsPresent));
+ 
+ 	foreach(l, opclass->procedures)
+ 	{
+ 		OpFamilyMember *proc = (OpFamilyMember *) lfirst(l);
+ 
+ 		if (proc->lefttype != opclass->intype ||
+ 			proc->righttype != opclass->intype)
+ 			continue;
+ 
+ 		if (proc->number < 1)
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
+ 					 errmsg("invalid support number for BRIN: %u",
+ 							proc->number)));
+ 
+ 		/* BRIN opclasses could contain any number of non-mandatory procedures */
+ 		if (proc->number > BRIN_MANDATORY_NPROCS)
+ 			continue;
+ 
+ 		if (procsPresent[proc->number - 1])
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
+ 					 errmsg("BRIN support number %u was defined more than once",
+ 							proc->number)));
+ 
+ 		procsPresent[proc->number - 1] = true;
+ 	}
+ 
+ 	/*
+ 	 * Don't use BRIN_NPROC because some procnumbers
+ 	 * are reserved for future use
+ 	 */
+ 	for (i = 0; i < BRIN_MANDATORY_NPROCS; i++)
+ 	{
+ 		if (!procsPresent[i])
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
+ 					 errmsg("BRIN support number %u is required", i + 1)));
+ 	}
+ 
+ 	foreach(l, opclass->operators)
+ 	{
+ 		OpFamilyMember *opr = (OpFamilyMember *) lfirst(l);
+ 
+ 		if (OidIsValid(opr->sortfamily))
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
+ 					 errmsg("BRIN doesn't support ORDER BY operators")));
+ 	}
+ }
+ 
+ /*
   * We use a BrinBuildState during initial construction of a BRIN index.
   * The running state is kept in a BrinMemTuple.
   */
*************** static void brin_vacuum_scan(Relation id
*** 80,94 ****
   * If the range is not currently summarized (i.e. the revmap returns NULL for
   * it), there's nothing to do.
   */
! Datum
! brininsert(PG_FUNCTION_ARGS)
  {
- 	Relation	idxRel = (Relation) PG_GETARG_POINTER(0);
- 	Datum	   *values = (Datum *) PG_GETARG_POINTER(1);
- 	bool	   *nulls = (bool *) PG_GETARG_POINTER(2);
- 	ItemPointer heaptid = (ItemPointer) PG_GETARG_POINTER(3);
- 
- 	/* we ignore the rest of our arguments */
  	BlockNumber pagesPerRange;
  	BrinDesc   *bdesc = NULL;
  	BrinRevmap *revmap;
--- 183,193 ----
   * If the range is not currently summarized (i.e. the revmap returns NULL for
   * it), there's nothing to do.
   */
! bool
! brininsert(Relation idxRel, Datum *values, bool *nulls,
! 		   ItemPointer heaptid, Relation heapRel,
! 		   IndexUniqueCheck checkUnique)
  {
  	BlockNumber pagesPerRange;
  	BrinDesc   *bdesc = NULL;
  	BrinRevmap *revmap;
*************** brininsert(PG_FUNCTION_ARGS)
*** 226,232 ****
  		MemoryContextDelete(tupcxt);
  	}
  
! 	return BoolGetDatum(false);
  }
  
  /*
--- 325,331 ----
  		MemoryContextDelete(tupcxt);
  	}
  
! 	return false;
  }
  
  /*
*************** brininsert(PG_FUNCTION_ARGS)
*** 236,247 ****
   * index was built with.  Note that since this cannot be changed while we're
   * holding lock on index, it's not necessary to recompute it during brinrescan.
   */
! Datum
! brinbeginscan(PG_FUNCTION_ARGS)
  {
- 	Relation	r = (Relation) PG_GETARG_POINTER(0);
- 	int			nkeys = PG_GETARG_INT32(1);
- 	int			norderbys = PG_GETARG_INT32(2);
  	IndexScanDesc scan;
  	BrinOpaque *opaque;
  
--- 335,343 ----
   * index was built with.  Note that since this cannot be changed while we're
   * holding lock on index, it's not necessary to recompute it during brinrescan.
   */
! IndexScanDesc
! brinbeginscan(Relation r, int nkeys, int norderbys)
  {
  	IndexScanDesc scan;
  	BrinOpaque *opaque;
  
*************** brinbeginscan(PG_FUNCTION_ARGS)
*** 252,258 ****
  	opaque->bo_bdesc = brin_build_desc(r);
  	scan->opaque = opaque;
  
! 	PG_RETURN_POINTER(scan);
  }
  
  /*
--- 348,354 ----
  	opaque->bo_bdesc = brin_build_desc(r);
  	scan->opaque = opaque;
  
! 	return scan;
  }
  
  /*
*************** brinbeginscan(PG_FUNCTION_ARGS)
*** 267,277 ****
   * unsummarized.  Pages in those ranges need to be returned regardless of scan
   * keys.
   */
! Datum
! bringetbitmap(PG_FUNCTION_ARGS)
  {
- 	IndexScanDesc scan = (IndexScanDesc) PG_GETARG_POINTER(0);
- 	TIDBitmap  *tbm = (TIDBitmap *) PG_GETARG_POINTER(1);
  	Relation	idxRel = scan->indexRelation;
  	Buffer		buf = InvalidBuffer;
  	BrinDesc   *bdesc;
--- 363,371 ----
   * unsummarized.  Pages in those ranges need to be returned regardless of scan
   * keys.
   */
! int64
! bringetbitmap(IndexScanDesc scan, TIDBitmap *tbm)
  {
  	Relation	idxRel = scan->indexRelation;
  	Buffer		buf = InvalidBuffer;
  	BrinDesc   *bdesc;
*************** bringetbitmap(PG_FUNCTION_ARGS)
*** 451,470 ****
  	 * returns, but we don't have a precise idea of the number of heap tuples
  	 * involved.
  	 */
! 	PG_RETURN_INT64(totalpages * 10);
  }
  
  /*
   * Re-initialize state for a BRIN index scan
   */
! Datum
! brinrescan(PG_FUNCTION_ARGS)
  {
- 	IndexScanDesc scan = (IndexScanDesc) PG_GETARG_POINTER(0);
- 	ScanKey		scankey = (ScanKey) PG_GETARG_POINTER(1);
- 
- 	/* other arguments ignored */
- 
  	/*
  	 * Other index AMs preprocess the scan keys at this point, or sometime
  	 * early during the scan; this lets them optimize by removing redundant
--- 545,560 ----
  	 * returns, but we don't have a precise idea of the number of heap tuples
  	 * involved.
  	 */
! 	return totalpages * 10;
  }
  
  /*
   * Re-initialize state for a BRIN index scan
   */
! void
! brinrescan(IndexScanDesc scan, ScanKey scankey, int nscankeys,
! 		   ScanKey orderbys, int norderbys)
  {
  	/*
  	 * Other index AMs preprocess the scan keys at this point, or sometime
  	 * early during the scan; this lets them optimize by removing redundant
*************** brinrescan(PG_FUNCTION_ARGS)
*** 476,513 ****
  	if (scankey && scan->numberOfKeys > 0)
  		memmove(scan->keyData, scankey,
  				scan->numberOfKeys * sizeof(ScanKeyData));
- 
- 	PG_RETURN_VOID();
  }
  
  /*
   * Close down a BRIN index scan
   */
! Datum
! brinendscan(PG_FUNCTION_ARGS)
  {
- 	IndexScanDesc scan = (IndexScanDesc) PG_GETARG_POINTER(0);
  	BrinOpaque *opaque = (BrinOpaque *) scan->opaque;
  
  	brinRevmapTerminate(opaque->bo_rmAccess);
  	brin_free_desc(opaque->bo_bdesc);
  	pfree(opaque);
- 
- 	PG_RETURN_VOID();
  }
  
! Datum
! brinmarkpos(PG_FUNCTION_ARGS)
  {
  	elog(ERROR, "BRIN does not support mark/restore");
- 	PG_RETURN_VOID();
  }
  
! Datum
! brinrestrpos(PG_FUNCTION_ARGS)
  {
  	elog(ERROR, "BRIN does not support mark/restore");
- 	PG_RETURN_VOID();
  }
  
  /*
--- 566,596 ----
  	if (scankey && scan->numberOfKeys > 0)
  		memmove(scan->keyData, scankey,
  				scan->numberOfKeys * sizeof(ScanKeyData));
  }
  
  /*
   * Close down a BRIN index scan
   */
! void
! brinendscan(IndexScanDesc scan)
  {
  	BrinOpaque *opaque = (BrinOpaque *) scan->opaque;
  
  	brinRevmapTerminate(opaque->bo_rmAccess);
  	brin_free_desc(opaque->bo_bdesc);
  	pfree(opaque);
  }
  
! void
! brinmarkpos(IndexScanDesc scan)
  {
  	elog(ERROR, "BRIN does not support mark/restore");
  }
  
! void
! brinrestrpos(IndexScanDesc scan)
  {
  	elog(ERROR, "BRIN does not support mark/restore");
  }
  
  /*
*************** brinbuildCallback(Relation index,
*** 579,590 ****
  /*
   * brinbuild() -- build a new BRIN index.
   */
! Datum
! brinbuild(PG_FUNCTION_ARGS)
  {
- 	Relation	heap = (Relation) PG_GETARG_POINTER(0);
- 	Relation	index = (Relation) PG_GETARG_POINTER(1);
- 	IndexInfo  *indexInfo = (IndexInfo *) PG_GETARG_POINTER(2);
  	IndexBuildResult *result;
  	double		reltuples;
  	double		idxtuples;
--- 662,670 ----
  /*
   * brinbuild() -- build a new BRIN index.
   */
! IndexBuildResult *
! brinbuild(Relation heap, Relation index, IndexInfo *indexInfo)
  {
  	IndexBuildResult *result;
  	double		reltuples;
  	double		idxtuples;
*************** brinbuild(PG_FUNCTION_ARGS)
*** 663,675 ****
  	result->heap_tuples = reltuples;
  	result->index_tuples = idxtuples;
  
! 	PG_RETURN_POINTER(result);
  }
  
! Datum
! brinbuildempty(PG_FUNCTION_ARGS)
  {
- 	Relation	index = (Relation) PG_GETARG_POINTER(0);
  	Buffer		metabuf;
  
  	/* An empty BRIN index has a metapage only. */
--- 743,754 ----
  	result->heap_tuples = reltuples;
  	result->index_tuples = idxtuples;
  
! 	return result;
  }
  
! void
! brinbuildempty(Relation index)
  {
  	Buffer		metabuf;
  
  	/* An empty BRIN index has a metapage only. */
*************** brinbuildempty(PG_FUNCTION_ARGS)
*** 686,693 ****
  	END_CRIT_SECTION();
  
  	UnlockReleaseBuffer(metabuf);
- 
- 	PG_RETURN_VOID();
  }
  
  /*
--- 765,770 ----
*************** brinbuildempty(PG_FUNCTION_ARGS)
*** 699,733 ****
   * tuple is deleted), meaning the need to re-run summarization on the affected
   * range.  Would need to add an extra flag in brintuples for that.
   */
! Datum
! brinbulkdelete(PG_FUNCTION_ARGS)
  {
- 	/* other arguments are not currently used */
- 	IndexBulkDeleteResult *stats =
- 	(IndexBulkDeleteResult *) PG_GETARG_POINTER(1);
- 
  	/* allocate stats if first time through, else re-use existing struct */
  	if (stats == NULL)
  		stats = (IndexBulkDeleteResult *) palloc0(sizeof(IndexBulkDeleteResult));
  
! 	PG_RETURN_POINTER(stats);
  }
  
  /*
   * This routine is in charge of "vacuuming" a BRIN index: we just summarize
   * ranges that are currently unsummarized.
   */
! Datum
! brinvacuumcleanup(PG_FUNCTION_ARGS)
  {
- 	IndexVacuumInfo *info = (IndexVacuumInfo *) PG_GETARG_POINTER(0);
- 	IndexBulkDeleteResult *stats =
- 	(IndexBulkDeleteResult *) PG_GETARG_POINTER(1);
  	Relation	heapRel;
  
  	/* No-op in ANALYZE ONLY mode */
  	if (info->analyze_only)
! 		PG_RETURN_POINTER(stats);
  
  	if (!stats)
  		stats = (IndexBulkDeleteResult *) palloc0(sizeof(IndexBulkDeleteResult));
--- 776,804 ----
   * tuple is deleted), meaning the need to re-run summarization on the affected
   * range.  Would need to add an extra flag in brintuples for that.
   */
! IndexBulkDeleteResult *
! brinbulkdelete(IndexVacuumInfo *info, IndexBulkDeleteResult *stats,
! 			   IndexBulkDeleteCallback callback, void *callback_state)
  {
  	/* allocate stats if first time through, else re-use existing struct */
  	if (stats == NULL)
  		stats = (IndexBulkDeleteResult *) palloc0(sizeof(IndexBulkDeleteResult));
  
! 	return stats;
  }
  
  /*
   * This routine is in charge of "vacuuming" a BRIN index: we just summarize
   * ranges that are currently unsummarized.
   */
! IndexBulkDeleteResult *
! brinvacuumcleanup(IndexVacuumInfo *info, IndexBulkDeleteResult *stats)
  {
  	Relation	heapRel;
  
  	/* No-op in ANALYZE ONLY mode */
  	if (info->analyze_only)
! 		return stats;
  
  	if (!stats)
  		stats = (IndexBulkDeleteResult *) palloc0(sizeof(IndexBulkDeleteResult));
*************** brinvacuumcleanup(PG_FUNCTION_ARGS)
*** 744,760 ****
  
  	heap_close(heapRel, AccessShareLock);
  
! 	PG_RETURN_POINTER(stats);
  }
  
  /*
   * reloptions processor for BRIN indexes
   */
! Datum
! brinoptions(PG_FUNCTION_ARGS)
  {
- 	Datum		reloptions = PG_GETARG_DATUM(0);
- 	bool		validate = PG_GETARG_BOOL(1);
  	relopt_value *options;
  	BrinOptions *rdopts;
  	int			numoptions;
--- 815,829 ----
  
  	heap_close(heapRel, AccessShareLock);
  
! 	return stats;
  }
  
  /*
   * reloptions processor for BRIN indexes
   */
! bytea *
! brinoptions(Datum reloptions, bool validate)
  {
  	relopt_value *options;
  	BrinOptions *rdopts;
  	int			numoptions;
*************** brinoptions(PG_FUNCTION_ARGS)
*** 767,773 ****
  
  	/* if none set, we're done */
  	if (numoptions == 0)
! 		PG_RETURN_NULL();
  
  	rdopts = allocateReloptStruct(sizeof(BrinOptions), options, numoptions);
  
--- 836,842 ----
  
  	/* if none set, we're done */
  	if (numoptions == 0)
! 		return NULL;
  
  	rdopts = allocateReloptStruct(sizeof(BrinOptions), options, numoptions);
  
*************** brinoptions(PG_FUNCTION_ARGS)
*** 776,782 ****
  
  	pfree(options);
  
! 	PG_RETURN_BYTEA_P(rdopts);
  }
  
  /*
--- 845,851 ----
  
  	pfree(options);
  
! 	return (bytea *)rdopts;
  }
  
  /*
diff --git a/src/backend/access/common/reloptions.c b/src/backend/access/common/reloptions.c
new file mode 100644
index 931dceb..b52846f
*** a/src/backend/access/common/reloptions.c
--- b/src/backend/access/common/reloptions.c
*************** untransformRelOptions(Datum options)
*** 891,897 ****
   * in the case of the tuple corresponding to an index, or InvalidOid otherwise.
   */
  bytea *
! extractRelOptions(HeapTuple tuple, TupleDesc tupdesc, Oid amoptions)
  {
  	bytea	   *options;
  	bool		isnull;
--- 891,897 ----
   * in the case of the tuple corresponding to an index, or InvalidOid otherwise.
   */
  bytea *
! extractRelOptions(HeapTuple tuple, TupleDesc tupdesc, amoptions_function amoptions)
  {
  	bytea	   *options;
  	bool		isnull;
*************** heap_reloptions(char relkind, Datum relo
*** 1379,1412 ****
   *	validate	error flag
   */
  bytea *
! index_reloptions(RegProcedure amoptions, Datum reloptions, bool validate)
  {
! 	FmgrInfo	flinfo;
! 	FunctionCallInfoData fcinfo;
! 	Datum		result;
! 
! 	Assert(RegProcedureIsValid(amoptions));
  
  	/* Assume function is strict */
  	if (!PointerIsValid(DatumGetPointer(reloptions)))
  		return NULL;
  
! 	/* Can't use OidFunctionCallN because we might get a NULL result */
! 	fmgr_info(amoptions, &flinfo);
! 
! 	InitFunctionCallInfoData(fcinfo, &flinfo, 2, InvalidOid, NULL, NULL);
! 
! 	fcinfo.arg[0] = reloptions;
! 	fcinfo.arg[1] = BoolGetDatum(validate);
! 	fcinfo.argnull[0] = false;
! 	fcinfo.argnull[1] = false;
! 
! 	result = FunctionCallInvoke(&fcinfo);
! 
! 	if (fcinfo.isnull || DatumGetPointer(result) == NULL)
! 		return NULL;
! 
! 	return DatumGetByteaP(result);
  }
  
  /*
--- 1379,1393 ----
   *	validate	error flag
   */
  bytea *
! index_reloptions(amoptions_function amoptions, Datum reloptions, bool validate)
  {
! 	Assert(amoptions);
  
  	/* Assume function is strict */
  	if (!PointerIsValid(DatumGetPointer(reloptions)))
  		return NULL;
  
! 	return amoptions(reloptions, validate);
  }
  
  /*
diff --git a/src/backend/access/gin/ginget.c b/src/backend/access/gin/ginget.c
new file mode 100644
index 54b2db8..29b22d6
*** a/src/backend/access/gin/ginget.c
--- b/src/backend/access/gin/ginget.c
*************** scanPendingInsert(IndexScanDesc scan, TI
*** 1772,1782 ****
  
  #define GinIsVoidRes(s)		( ((GinScanOpaque) scan->opaque)->isVoidRes )
  
! Datum
! gingetbitmap(PG_FUNCTION_ARGS)
  {
- 	IndexScanDesc scan = (IndexScanDesc) PG_GETARG_POINTER(0);
- 	TIDBitmap  *tbm = (TIDBitmap *) PG_GETARG_POINTER(1);
  	GinScanOpaque so = (GinScanOpaque) scan->opaque;
  	int64		ntids;
  	ItemPointerData iptr;
--- 1772,1780 ----
  
  #define GinIsVoidRes(s)		( ((GinScanOpaque) scan->opaque)->isVoidRes )
  
! int64
! gingetbitmap(IndexScanDesc scan, TIDBitmap *tbm)
  {
  	GinScanOpaque so = (GinScanOpaque) scan->opaque;
  	int64		ntids;
  	ItemPointerData iptr;
*************** gingetbitmap(PG_FUNCTION_ARGS)
*** 1827,1831 ****
  		ntids++;
  	}
  
! 	PG_RETURN_INT64(ntids);
  }
--- 1825,1829 ----
  		ntids++;
  	}
  
! 	return ntids;
  }
diff --git a/src/backend/access/gin/gininsert.c b/src/backend/access/gin/gininsert.c
new file mode 100644
index 49e9185..92701b9
*** a/src/backend/access/gin/gininsert.c
--- b/src/backend/access/gin/gininsert.c
*************** ginBuildCallback(Relation index, HeapTup
*** 306,317 ****
  	MemoryContextSwitchTo(oldCtx);
  }
  
! Datum
! ginbuild(PG_FUNCTION_ARGS)
  {
- 	Relation	heap = (Relation) PG_GETARG_POINTER(0);
- 	Relation	index = (Relation) PG_GETARG_POINTER(1);
- 	IndexInfo  *indexInfo = (IndexInfo *) PG_GETARG_POINTER(2);
  	IndexBuildResult *result;
  	double		reltuples;
  	GinBuildState buildstate;
--- 306,314 ----
  	MemoryContextSwitchTo(oldCtx);
  }
  
! IndexBuildResult *
! ginbuild(Relation heap, Relation index, IndexInfo *indexInfo)
  {
  	IndexBuildResult *result;
  	double		reltuples;
  	GinBuildState buildstate;
*************** ginbuild(PG_FUNCTION_ARGS)
*** 429,444 ****
  	result->heap_tuples = reltuples;
  	result->index_tuples = buildstate.indtuples;
  
! 	PG_RETURN_POINTER(result);
  }
  
  /*
   *	ginbuildempty() -- build an empty gin index in the initialization fork
   */
! Datum
! ginbuildempty(PG_FUNCTION_ARGS)
  {
- 	Relation	index = (Relation) PG_GETARG_POINTER(0);
  	Buffer		RootBuffer,
  				MetaBuffer;
  
--- 426,440 ----
  	result->heap_tuples = reltuples;
  	result->index_tuples = buildstate.indtuples;
  
! 	return result;
  }
  
  /*
   *	ginbuildempty() -- build an empty gin index in the initialization fork
   */
! void
! ginbuildempty(Relation index)
  {
  	Buffer		RootBuffer,
  				MetaBuffer;
  
*************** ginbuildempty(PG_FUNCTION_ARGS)
*** 463,470 ****
  	/* Unlock and release the buffers. */
  	UnlockReleaseBuffer(MetaBuffer);
  	UnlockReleaseBuffer(RootBuffer);
- 
- 	PG_RETURN_VOID();
  }
  
  /*
--- 459,464 ----
*************** ginHeapTupleInsert(GinState *ginstate, O
*** 489,506 ****
  					   item, 1, NULL);
  }
  
! Datum
! gininsert(PG_FUNCTION_ARGS)
  {
- 	Relation	index = (Relation) PG_GETARG_POINTER(0);
- 	Datum	   *values = (Datum *) PG_GETARG_POINTER(1);
- 	bool	   *isnull = (bool *) PG_GETARG_POINTER(2);
- 	ItemPointer ht_ctid = (ItemPointer) PG_GETARG_POINTER(3);
- 
- #ifdef NOT_USED
- 	Relation	heapRel = (Relation) PG_GETARG_POINTER(4);
- 	IndexUniqueCheck checkUnique = (IndexUniqueCheck) PG_GETARG_INT32(5);
- #endif
  	GinState	ginstate;
  	MemoryContext oldCtx;
  	MemoryContext insertCtx;
--- 483,493 ----
  					   item, 1, NULL);
  }
  
! bool
! gininsert(Relation index, Datum *values, bool *isnull,
! 		  ItemPointer ht_ctid, Relation heapRel,
! 		  IndexUniqueCheck checkUnique)
  {
  	GinState	ginstate;
  	MemoryContext oldCtx;
  	MemoryContext insertCtx;
*************** gininsert(PG_FUNCTION_ARGS)
*** 541,545 ****
  	MemoryContextSwitchTo(oldCtx);
  	MemoryContextDelete(insertCtx);
  
! 	PG_RETURN_BOOL(false);
  }
--- 528,532 ----
  	MemoryContextSwitchTo(oldCtx);
  	MemoryContextDelete(insertCtx);
  
! 	return false;
  }
diff --git a/src/backend/access/gin/ginscan.c b/src/backend/access/gin/ginscan.c
new file mode 100644
index ac3a92b..d97a9db
*** a/src/backend/access/gin/ginscan.c
--- b/src/backend/access/gin/ginscan.c
***************
*** 21,32 ****
  #include "utils/rel.h"
  
  
! Datum
! ginbeginscan(PG_FUNCTION_ARGS)
  {
- 	Relation	rel = (Relation) PG_GETARG_POINTER(0);
- 	int			nkeys = PG_GETARG_INT32(1);
- 	int			norderbys = PG_GETARG_INT32(2);
  	IndexScanDesc scan;
  	GinScanOpaque so;
  
--- 21,29 ----
  #include "utils/rel.h"
  
  
! IndexScanDesc
! ginbeginscan(Relation rel, int nkeys, int norderbys)
  {
  	IndexScanDesc scan;
  	GinScanOpaque so;
  
*************** ginbeginscan(PG_FUNCTION_ARGS)
*** 53,59 ****
  
  	scan->opaque = so;
  
! 	PG_RETURN_POINTER(scan);
  }
  
  /*
--- 50,56 ----
  
  	scan->opaque = so;
  
! 	return scan;
  }
  
  /*
*************** ginNewScanKey(IndexScanDesc scan)
*** 417,429 ****
  	pgstat_count_index_scan(scan->indexRelation);
  }
  
! Datum
! ginrescan(PG_FUNCTION_ARGS)
  {
- 	IndexScanDesc scan = (IndexScanDesc) PG_GETARG_POINTER(0);
- 	ScanKey		scankey = (ScanKey) PG_GETARG_POINTER(1);
- 
- 	/* remaining arguments are ignored */
  	GinScanOpaque so = (GinScanOpaque) scan->opaque;
  
  	ginFreeScanKeys(so);
--- 414,423 ----
  	pgstat_count_index_scan(scan->indexRelation);
  }
  
! void
! ginrescan(IndexScanDesc scan, ScanKey scankey, int nscankeys,
! 		  ScanKey orderbys, int norderbys)
  {
  	GinScanOpaque so = (GinScanOpaque) scan->opaque;
  
  	ginFreeScanKeys(so);
*************** ginrescan(PG_FUNCTION_ARGS)
*** 433,447 ****
  		memmove(scan->keyData, scankey,
  				scan->numberOfKeys * sizeof(ScanKeyData));
  	}
- 
- 	PG_RETURN_VOID();
  }
  
  
! Datum
! ginendscan(PG_FUNCTION_ARGS)
  {
- 	IndexScanDesc scan = (IndexScanDesc) PG_GETARG_POINTER(0);
  	GinScanOpaque so = (GinScanOpaque) scan->opaque;
  
  	ginFreeScanKeys(so);
--- 427,438 ----
  		memmove(scan->keyData, scankey,
  				scan->numberOfKeys * sizeof(ScanKeyData));
  	}
  }
  
  
! void
! ginendscan(IndexScanDesc scan)
  {
  	GinScanOpaque so = (GinScanOpaque) scan->opaque;
  
  	ginFreeScanKeys(so);
*************** ginendscan(PG_FUNCTION_ARGS)
*** 450,469 ****
  	MemoryContextDelete(so->keyCtx);
  
  	pfree(so);
- 
- 	PG_RETURN_VOID();
  }
  
! Datum
! ginmarkpos(PG_FUNCTION_ARGS)
  {
  	elog(ERROR, "GIN does not support mark/restore");
- 	PG_RETURN_VOID();
  }
  
! Datum
! ginrestrpos(PG_FUNCTION_ARGS)
  {
  	elog(ERROR, "GIN does not support mark/restore");
- 	PG_RETURN_VOID();
  }
--- 441,456 ----
  	MemoryContextDelete(so->keyCtx);
  
  	pfree(so);
  }
  
! void
! ginmarkpos(IndexScanDesc scan)
  {
  	elog(ERROR, "GIN does not support mark/restore");
  }
  
! void
! ginrestrpos(IndexScanDesc scan)
  {
  	elog(ERROR, "GIN does not support mark/restore");
  }
diff --git a/src/backend/access/gin/ginutil.c b/src/backend/access/gin/ginutil.c
new file mode 100644
index cb4e32f..51c1559
*** a/src/backend/access/gin/ginutil.c
--- b/src/backend/access/gin/ginutil.c
***************
*** 22,28 ****
--- 22,140 ----
  #include "miscadmin.h"
  #include "storage/indexfsm.h"
  #include "storage/lmgr.h"
+ #include "utils/selfuncs.h"
+ 
+ 
+ /*
+  * GIN handler function: return IndexAmRoutine with access method parameters
+  * and callbacks.
+  */
+ Datum
+ ginhandler(PG_FUNCTION_ARGS)
+ {
+ 	IndexAmRoutine *amroutine = makeNode(IndexAmRoutine);
+ 
+ 	amroutine->amstrategies = 0;
+ 	amroutine->amsupport = 6;
+ 	amroutine->amcanorder = false;
+ 	amroutine->amcanorderbyop = false;
+ 	amroutine->amcanbackward = false;
+ 	amroutine->amcanunique = false;
+ 	amroutine->amcanmulticol = true;
+ 	amroutine->amoptionalkey = true;
+ 	amroutine->amsearcharray = false;
+ 	amroutine->amsearchnulls = false;
+ 	amroutine->amstorage = true;
+ 	amroutine->amclusterable = false;
+ 	amroutine->ampredlocks = false;
+ 	amroutine->amkeytype = 0;
+ 
+ 	amroutine->aminsert = gininsert;
+ 	amroutine->ambeginscan = ginbeginscan;
+ 	amroutine->amgettuple = NULL;
+ 	amroutine->amgetbitmap = gingetbitmap;
+ 	amroutine->amrescan = ginrescan;
+ 	amroutine->amendscan = ginendscan;
+ 	amroutine->ammarkpos = ginmarkpos;
+ 	amroutine->amrestrpos = ginrestrpos;
+ 	amroutine->ambuild = ginbuild;
+ 	amroutine->ambuildempty = ginbuildempty;
+ 	amroutine->ambulkdelete = ginbulkdelete;
+ 	amroutine->amvacuumcleanup = ginvacuumcleanup;
+ 	amroutine->amcanreturn = NULL;
+ 	amroutine->amcostestimate = gincostestimate;
+ 	amroutine->amoptions = ginoptions;
+ 	amroutine->amvalidate = ginvalidate;
+ 
+ 	PG_RETURN_POINTER(amroutine);
+ }
+ 
+ void
+ ginvalidate(OpClassInfo *opclass)
+ {
+ 	ListCell   *l;
+ 	bool		procsPresent[GINNProcs];
+ 	int			i;
+ 
+ 	memset(procsPresent, 0, sizeof(procsPresent));
+ 
+ 	foreach(l, opclass->procedures)
+ 	{
+ 		OpFamilyMember *proc = (OpFamilyMember *) lfirst(l);
+ 
+ 		if (proc->lefttype != opclass->intype ||
+ 			proc->righttype != opclass->intype)
+ 			continue;
+ 
+ 		if (proc->number < 1 || proc->number > GINNProcs)
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
+ 					 errmsg("invalid support number for GIN: %u",
+ 							proc->number)));
  
+ 		if (procsPresent[proc->number - 1])
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
+ 					 errmsg("GIN support number %u was defined more than once",
+ 							proc->number)));
+ 
+ 		procsPresent[proc->number - 1] = true;
+ 	}
+ 
+ 	for (i = 0; i < GINNProcs; i++)
+ 	{
+ 		if (i+1 == GIN_COMPARE_PARTIAL_PROC)
+ 			continue; /* optional method */
+ 		if (i+1 == GIN_CONSISTENT_PROC || i+1 == GIN_TRICONSISTENT_PROC)
+ 			continue; /* don't need to have both, see check below loop */
+ 
+ 		if (!procsPresent[i])
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
+ 					 errmsg("GIN support number %u is required", i + 1)));
+ 	}
+ 
+ 	if (!procsPresent[GIN_CONSISTENT_PROC - 1]
+ 								&& !procsPresent[GIN_TRICONSISTENT_PROC - 1])
+ 	{
+ 		ereport(ERROR,
+ 				(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
+ 				 errmsg("at least one of consistent support (number %u) "
+ 						"and triconsistent support (number %u) is "
+ 						"is required",
+ 						GIN_CONSISTENT_PROC, GIN_TRICONSISTENT_PROC)));
+ 	}
+ 
+ 	foreach(l, opclass->operators)
+ 	{
+ 		OpFamilyMember *opr = (OpFamilyMember *) lfirst(l);
+ 
+ 		if (OidIsValid(opr->sortfamily))
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
+ 					 errmsg("GIN doesn't support ORDER BY operators")));
+ 	}
+ }
  
  /*
   * initGinState: fill in an empty GinState struct to describe the index
*************** ginExtractEntries(GinState *ginstate, Of
*** 516,526 ****
  	return entries;
  }
  
! Datum
! ginoptions(PG_FUNCTION_ARGS)
  {
- 	Datum		reloptions = PG_GETARG_DATUM(0);
- 	bool		validate = PG_GETARG_BOOL(1);
  	relopt_value *options;
  	GinOptions *rdopts;
  	int			numoptions;
--- 628,636 ----
  	return entries;
  }
  
! bytea *
! ginoptions(Datum reloptions, bool validate)
  {
  	relopt_value *options;
  	GinOptions *rdopts;
  	int			numoptions;
*************** ginoptions(PG_FUNCTION_ARGS)
*** 535,541 ****
  
  	/* if none set, we're done */
  	if (numoptions == 0)
! 		PG_RETURN_NULL();
  
  	rdopts = allocateReloptStruct(sizeof(GinOptions), options, numoptions);
  
--- 645,651 ----
  
  	/* if none set, we're done */
  	if (numoptions == 0)
! 		return NULL;
  
  	rdopts = allocateReloptStruct(sizeof(GinOptions), options, numoptions);
  
*************** ginoptions(PG_FUNCTION_ARGS)
*** 544,550 ****
  
  	pfree(options);
  
! 	PG_RETURN_BYTEA_P(rdopts);
  }
  
  /*
--- 654,660 ----
  
  	pfree(options);
  
! 	return (bytea *)rdopts;
  }
  
  /*
diff --git a/src/backend/access/gin/ginvacuum.c b/src/backend/access/gin/ginvacuum.c
new file mode 100644
index 323cfb0..5b38607
*** a/src/backend/access/gin/ginvacuum.c
--- b/src/backend/access/gin/ginvacuum.c
*************** ginVacuumEntryPage(GinVacuumState *gvs, 
*** 513,525 ****
  	return (tmppage == origpage) ? NULL : tmppage;
  }
  
! Datum
! ginbulkdelete(PG_FUNCTION_ARGS)
  {
- 	IndexVacuumInfo *info = (IndexVacuumInfo *) PG_GETARG_POINTER(0);
- 	IndexBulkDeleteResult *stats = (IndexBulkDeleteResult *) PG_GETARG_POINTER(1);
- 	IndexBulkDeleteCallback callback = (IndexBulkDeleteCallback) PG_GETARG_POINTER(2);
- 	void	   *callback_state = (void *) PG_GETARG_POINTER(3);
  	Relation	index = info->index;
  	BlockNumber blkno = GIN_ROOT_BLKNO;
  	GinVacuumState gvs;
--- 513,522 ----
  	return (tmppage == origpage) ? NULL : tmppage;
  }
  
! IndexBulkDeleteResult *
! ginbulkdelete(IndexVacuumInfo *info, IndexBulkDeleteResult *stats,
! 			  IndexBulkDeleteCallback callback, void *callback_state)
  {
  	Relation	index = info->index;
  	BlockNumber blkno = GIN_ROOT_BLKNO;
  	GinVacuumState gvs;
*************** ginbulkdelete(PG_FUNCTION_ARGS)
*** 634,647 ****
  
  	MemoryContextDelete(gvs.tmpCxt);
  
! 	PG_RETURN_POINTER(gvs.result);
  }
  
! Datum
! ginvacuumcleanup(PG_FUNCTION_ARGS)
  {
- 	IndexVacuumInfo *info = (IndexVacuumInfo *) PG_GETARG_POINTER(0);
- 	IndexBulkDeleteResult *stats = (IndexBulkDeleteResult *) PG_GETARG_POINTER(1);
  	Relation	index = info->index;
  	bool		needLock;
  	BlockNumber npages,
--- 631,642 ----
  
  	MemoryContextDelete(gvs.tmpCxt);
  
! 	return gvs.result;
  }
  
! IndexBulkDeleteResult *
! ginvacuumcleanup(IndexVacuumInfo *info, IndexBulkDeleteResult *stats)
  {
  	Relation	index = info->index;
  	bool		needLock;
  	BlockNumber npages,
*************** ginvacuumcleanup(PG_FUNCTION_ARGS)
*** 661,667 ****
  			initGinState(&ginstate, index);
  			ginInsertCleanup(&ginstate, true, true, stats);
  		}
! 		PG_RETURN_POINTER(stats);
  	}
  
  	/*
--- 656,662 ----
  			initGinState(&ginstate, index);
  			ginInsertCleanup(&ginstate, true, true, stats);
  		}
! 		return stats;
  	}
  
  	/*
*************** ginvacuumcleanup(PG_FUNCTION_ARGS)
*** 746,750 ****
  	if (needLock)
  		UnlockRelationForExtension(index, ExclusiveLock);
  
! 	PG_RETURN_POINTER(stats);
  }
--- 741,745 ----
  	if (needLock)
  		UnlockRelationForExtension(index, ExclusiveLock);
  
! 	return stats;
  }
